<?php
/**
 * Plugin for Pluxml
 * @author	DPFPIC
 * Site : http://monblog.dpfpic.com/
 * Licence GNU_GPL
 **/
 
if(!defined('PLX_ROOT')) exit;

# Control du token du formulaire
plxToken::validateFormToken($_POST);

# Control de l'accès à la page en fonction du profil de l'utilisateur connecté
$plxAdmin->checkProfil(PROFIL_ADMIN, PROFIL_MANAGER);

$tp = (isset($_GET['tp'])) ? $_GET['tp'] : 'b';

# On valide les bannières
if(!empty($_POST)) {

	$plxPlugin->bannersquotes->editBannersQuotes($_POST);
	$plxPlugin->bannersquotes->editGroups($_POST);	
	header('Location: plugin.php?p=plxBannersQuotes&tp='.$_POST['tp']);
	exit;
}
?>
<script type="text/javascript">

	$(document).ready(function() {
		$("#deleteGroup").click(function(){
		
		    var select = document.getElementById('id_list_group').value;
			var option = $("#id_list_group option:selected");
			
			if(select == '') {
			alert("<?php $plxPlugin->lang('L_BQ_DEFAULT_HIDDEN') ?>");
			} else {
			if (!confirm('<?php echo L_CONFIRM_DELETE ?>')) return false;
			$("select[id$='_group']").each(function(){
				if($(this).val() == option.val()) {
					$("option[value='']", this).prop('selected', true);
				}	
			});
			$("select[id$='_group'] option[value="+option.val()+"]").remove();
			}
		});
		
		$("#addGroup").click(function(){
			var text = $("#id_newgroup").val();
			var options = new Option(text, text);
			$("select[id$='_group']").append($(options));
		});
	});

	function OnSelectionChange () {
		var update = document.createElement("input");
		update.setAttribute("type", "hidden");
		update.setAttribute("name", "update");
		update.setAttribute("value", "update");
		var quote = document.createElement("input");
		quote.setAttribute("type", "hidden");
		quote.setAttribute("name", "quote");
		quote.setAttribute("value", "quote");
		form_bannersquotes.appendChild(update);
		form_bannersquotes.appendChild(quote);
        document.querySelectorAll("input[type=submit]")[0].click();     
    }
    </script>
</script>
<form action="plugin.php?p=plxBannersQuotes&tp=<?php echo $tp; ?>" method="post" name="form_bannersquotes" id="form_bannersquotes">
<div id="groups" class="inline-form action-bar">
	<h2><?php echo $plxPlugin->lang('L_BQ_GROUP_TITLE'); ?></h2>
	<p>&nbsp;</p>
	<?php $plxPlugin->lang('L_BQ_GROUP_ADD'); ?>&nbsp;:&nbsp;<?php plxUtils::printInput("newgroup", '', 'text', '10-15'); ?>
	<input type="submit" id="addGroup" value="<?php echo L_OK ?>" />&nbsp;&nbsp;&nbsp;&nbsp;
	<?php $plxPlugin->lang('L_BQ_GROUP_DEL'); ?>&nbsp;:&nbsp;
	<?php $selectGroup = $plxPlugin->bannersquotes->buildSelectGroup($plxPlugin->getlang('L_BQ_DEFAULT')); ?>
	<?php plxUtils::printSelect("del_group", $selectGroup, '', false, '','id_del_group'); ?>
	<input type="submit" name="submit" value="<?php echo L_OK ?>" onclick="Check=confirm('<?php echo L_CONFIRM_DELETE ?>');if(Check==false) {return false;} else {this.form.target='_self';return true;}" />&nbsp;&nbsp;&nbsp;&nbsp;	
	<?php plxUtils::printSelect('selection', array( '' =>L_FOR_SELECTION, 'delete' =>L_DELETE), '', false, '', 'id_selection') ?>
	<input type="submit" name="submit" value="<?php echo L_OK ?>" onclick="return confirmAction(this.form, 'id_selection', 'delete', 'id_bannersquotes[]', '<?php echo L_CONFIRM_DELETE ?>')" />
	<?php echo plxToken::getTokenPostMethod() ?>
	&nbsp;&nbsp;&nbsp;
	<input type="submit" id="update" name="update" value="<?php echo $plxPlugin->lang('L_BQ_UPDATE') ?>" />
</div>

<h2><?php $plxPlugin->lang('L_BQ_TITLE_BANNERSQUOTES') ?></h2>

<div class="scrollable-table">
	<table id="banners-table" class="full-width">
	<thead>
		<tr>
			<th class="checkbox"><input type="checkbox" onclick="checkAll(this.form, 'id_bannersquotes[]')" /></th>
			<th style="width:80px"><?php $plxPlugin->lang('L_BQ_ID') ?></th>
			<th><?php $plxPlugin->lang('L_BQ_GROUP_LIST') ?></th>	
			<th><?php $plxPlugin->lang('L_BQ_TYPE') ?></th>			
			<th><?php $plxPlugin->lang('L_BQ_TITLE') ?></th>
			<th><?php $plxPlugin->lang('L_BQ_URL') ?></th>			
			<th><?php $plxPlugin->lang('L_BQ_URL_IMG') ?>&nbsp;&nbsp;<a class="hint"><span><?php $plxPlugin->lang('L_BQ_HELP_HREF') ?></span></a></th>
			<th><?php $plxPlugin->lang('L_BQ_ACTIVE') ?></th>
		</tr>
	</thead>
	<tbody>
	<?php
	# Initialisation de l'ordre
	$num = 0;
	$dfolder = $plxPlugin->getParam('bqBfolder');
	# Si on a des banières existantes
	if($plxPlugin->bannersquotes->aBannersQuotes) {
		foreach($plxPlugin->bannersquotes->aBannersQuotes as $k=>$v) { # Pour chaque bannière/citations
			$ordre = ++$num;
			echo '<tr class="line-'.($num%2).'">';
			echo '<td><input type="checkbox" name="id_bannersquotes[]" value="'.$k.'" /><input type="hidden" name="bannersquotesNum[]" value="'.$k.'" /></td>';
			echo '<td>'.$k.'</td><td>';
			plxUtils::printSelect($k.'_group', $selectGroup, $v['group']);
			echo '</td><td>';			
			$plxPlugin->bannersquotes->printSelectType($k.'_type', array('b'=>$plxPlugin->getlang('L_BQ_TBANNERS'),'q'=>$plxPlugin->getlang('L_BQ_TQUOTES')), $v['type']);	
			if ($v['type'] == 'b') { echo '</td><td>'; } else { echo '</td><td colspan="3">'; }	
			if ($v['type'] == 'b') { $long = '32-100';} else { $long = '135-255';}		
			plxUtils::printInput($k.'_title', plxUtils::strCheck($v['title']), 'text', $long);	
			if ($v['type'] == 'b') {		
			echo '</td><td>';
			plxUtils::printInput($k.'_url', plxUtils::strCheck($v['url']), 'text', '32-255');
			echo '</td><td>';
			plxUtils::printInput($k.'_url_img', plxUtils::strCheck($v['url_img']), 'text', '32-255');
			echo '<a title="" id="toggler" href="javascript:void(0)" onclick="plxmedia.openPopup(\'../../plugins/plxBannersQuotes/filemanager.php?id='.$k.'_url_img&df='.$dfolder.' \');" style="outline:none; text-decoration: none">';
			echo '<img src="../../plugins/plxBannersQuotes/img/gfichiers.png" height="16" width="16" style="vertical-align: middle"></a>';
			}
			echo '</td><td>';			
			plxUtils::printSelect($k.'_active', array('1'=>L_YES,'0'=>L_NO), $v['active']);
			echo '</td><tr>';
		}
		# On récupère le dernier identifiant
		$a = array_keys($plxPlugin->bannersquotes->aBannersQuotes);
		rsort($a);
	} else {
		$a['0'] = 0;
	}

	$new_BannersQuotes_id = $plxPlugin->bannersquotes->nextid_BannersQuotes($a['0']);
	$tp = (isset($_GET['tp'])) ? $_GET['tp'] : 'b';
	?>
		<tr class="new">
			<td>&nbsp;</td>
			<td><?php echo $plxPlugin->lang('L_BQ_BANNERQUOTE') ?></td>
			<td>
			<?php
				echo '<input type="hidden" name="bannersquotesNum[]" value="'.$new_BannersQuotes_id.'" />';
				plxUtils::printSelect($new_BannersQuotes_id.'_group', $selectGroup, '');
				echo '</td><td>';				
				$plxPlugin->bannersquotes->printSelectType($new_BannersQuotes_id.'_type', array('b'=>$plxPlugin->getlang('L_BQ_TBANNERS'),'q'=>$plxPlugin->getlang('L_BQ_TQUOTES')), $tp);	
				echo '<input type="hidden" name="lastid" value="'.$new_BannersQuotes_id.'" />';		
				if ($tp == 'b') { echo '</td><td>'; } else { echo '</td><td colspan="3">'; }	
				if ($tp == 'b') { $long = '32-100';} else { $long = '135-255';}						
				plxUtils::printInput($new_BannersQuotes_id.'_title', '', 'text', $long);
				if ($tp == 'b') {				
				echo '</td><td>';
				plxUtils::printInput($new_BannersQuotes_id.'_url', '', 'text', '32-255');
				echo '</td><td>';
				plxUtils::printInput($new_BannersQuotes_id.'_url_img', '', 'text', '32-255');
				echo '<a title="" id="toggler" href="javascript:void(0)" onclick="plxmedia.openPopup(\'../../plugins/plxBannersQuotes/filemanager.php?id='.$new_BannersQuotes_id.'_url_img&df='.$dfolder.' \');" style="outline:none; text-decoration: none">';
				echo '<img src="../../plugins/plxBannersQuotes/img/gfichiers.png" height="16" width="16" style="vertical-align: middle"></a>';
				}
				echo '</td><td>';				
				plxUtils::printSelect($new_BannersQuotes_id.'_active', array('1'=>L_YES,'0'=>L_NO), '1');
			?>
			</td>
		</tr>
	</tbody>
	</table>
</div>	
</form>
